<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="pt"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>LoggingConfiguration.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Credenciamento</a> &gt; <a href="index.source.html" class="el_package">br.edu.unifacisa.lti.config</a> &gt; <span class="el_source">LoggingConfiguration.java</span></div><h1>LoggingConfiguration.java</h1><pre class="source lang-java linenums">package br.edu.unifacisa.lti.config;

import io.github.jhipster.config.JHipsterProperties;

import ch.qos.logback.classic.AsyncAppender;
import ch.qos.logback.classic.Level;
import ch.qos.logback.classic.LoggerContext;
import ch.qos.logback.classic.spi.LoggerContextListener;
import ch.qos.logback.core.spi.ContextAwareBase;
import net.logstash.logback.appender.LogstashSocketAppender;
import net.logstash.logback.stacktrace.ShortenedThrowableConverter;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Configuration;

@Configuration
public class LoggingConfiguration {

<span class="fc" id="L20">    private final Logger log = LoggerFactory.getLogger(LoggingConfiguration.class);</span>

<span class="fc" id="L22">    private LoggerContext context = (LoggerContext) LoggerFactory.getILoggerFactory();</span>

    private final String appName;

    private final String serverPort;

    private final JHipsterProperties jHipsterProperties;

    public LoggingConfiguration(@Value(&quot;${spring.application.name}&quot;) String appName, @Value(&quot;${server.port}&quot;) String serverPort,
<span class="fc" id="L31">         JHipsterProperties jHipsterProperties) {</span>
<span class="fc" id="L32">        this.appName = appName;</span>
<span class="fc" id="L33">        this.serverPort = serverPort;</span>
<span class="fc" id="L34">        this.jHipsterProperties = jHipsterProperties;</span>
<span class="pc bpc" id="L35" title="1 of 2 branches missed.">        if (jHipsterProperties.getLogging().getLogstash().isEnabled()) {</span>
<span class="nc" id="L36">            addLogstashAppender(context);</span>

            // Add context listener
<span class="nc" id="L39">            LogbackLoggerContextListener loggerContextListener = new LogbackLoggerContextListener();</span>
<span class="nc" id="L40">            loggerContextListener.setContext(context);</span>
<span class="nc" id="L41">            context.addListener(loggerContextListener);</span>
        }
<span class="fc" id="L43">    }</span>

    public void addLogstashAppender(LoggerContext context) {
<span class="nc" id="L46">        log.info(&quot;Initializing Logstash logging&quot;);</span>

<span class="nc" id="L48">        LogstashSocketAppender logstashAppender = new LogstashSocketAppender();</span>
<span class="nc" id="L49">        logstashAppender.setName(&quot;LOGSTASH&quot;);</span>
<span class="nc" id="L50">        logstashAppender.setContext(context);</span>
<span class="nc" id="L51">        String customFields = &quot;{\&quot;app_name\&quot;:\&quot;&quot; + appName + &quot;\&quot;,\&quot;app_port\&quot;:\&quot;&quot; + serverPort + &quot;\&quot;}&quot;;</span>

        // Set the Logstash appender config from JHipster properties
<span class="nc" id="L54">        logstashAppender.setSyslogHost(jHipsterProperties.getLogging().getLogstash().getHost());</span>
<span class="nc" id="L55">        logstashAppender.setPort(jHipsterProperties.getLogging().getLogstash().getPort());</span>
<span class="nc" id="L56">        logstashAppender.setCustomFields(customFields);</span>

        // Limit the maximum length of the forwarded stacktrace so that it won't exceed the 8KB UDP limit of logstash
<span class="nc" id="L59">        ShortenedThrowableConverter throwableConverter = new ShortenedThrowableConverter();</span>
<span class="nc" id="L60">        throwableConverter.setMaxLength(7500);</span>
<span class="nc" id="L61">        throwableConverter.setRootCauseFirst(true);</span>
<span class="nc" id="L62">        logstashAppender.setThrowableConverter(throwableConverter);</span>

<span class="nc" id="L64">        logstashAppender.start();</span>

        // Wrap the appender in an Async appender for performance
<span class="nc" id="L67">        AsyncAppender asyncLogstashAppender = new AsyncAppender();</span>
<span class="nc" id="L68">        asyncLogstashAppender.setContext(context);</span>
<span class="nc" id="L69">        asyncLogstashAppender.setName(&quot;ASYNC_LOGSTASH&quot;);</span>
<span class="nc" id="L70">        asyncLogstashAppender.setQueueSize(jHipsterProperties.getLogging().getLogstash().getQueueSize());</span>
<span class="nc" id="L71">        asyncLogstashAppender.addAppender(logstashAppender);</span>
<span class="nc" id="L72">        asyncLogstashAppender.start();</span>

<span class="nc" id="L74">        context.getLogger(&quot;ROOT&quot;).addAppender(asyncLogstashAppender);</span>
<span class="nc" id="L75">    }</span>

    /**
     * Logback configuration is achieved by configuration file and API.
     * When configuration file change is detected, the configuration is reset.
     * This listener ensures that the programmatic configuration is also re-applied after reset.
     */
<span class="nc" id="L82">    class LogbackLoggerContextListener extends ContextAwareBase implements LoggerContextListener {</span>

        @Override
        public boolean isResetResistant() {
<span class="nc" id="L86">            return true;</span>
        }

        @Override
        public void onStart(LoggerContext context) {
<span class="nc" id="L91">            addLogstashAppender(context);</span>
<span class="nc" id="L92">        }</span>

        @Override
        public void onReset(LoggerContext context) {
<span class="nc" id="L96">            addLogstashAppender(context);</span>
<span class="nc" id="L97">        }</span>

        @Override
        public void onStop(LoggerContext context) {
            // Nothing to do.
<span class="nc" id="L102">        }</span>

        @Override
        public void onLevelChange(ch.qos.logback.classic.Logger logger, Level level) {
            // Nothing to do.
<span class="nc" id="L107">        }</span>
    }

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.7.9.201702052155</span></div></body></html>